#include <stdlib.h>
#include <stdio.h>

int limpiar(char *linea) //Esta funcin elimina los dos primeros caracteres de una linea.
{
int i;
for(i=2;i<100;i++) linea[i-2]=linea[i];
return 1;
}

int main(int argc, char *argv[])
{
int c=1,j,k,l,n;
FILE *datos, *cabeza, *pie, *salida;
char linea[100], enotas[100], nota[3], personal[100], direccion[50], u, enviar[40];

if (argc<3)
	{
	printf("\n Modo de empleo del comando %s:\n\n\t %s \"Subject\" <archivo de entrada>\n\n", argv[0], argv[0]);
	exit(1);
	}
datos=fopen(argv[2], "r"); // Asigna el archivo indicado en la linea de comandos al puntero datos.
cabeza=fopen("cabeza", "w");
pie=fopen("pie", "w");


// Ahora se generan dos archivos: 
//	cabeza --> con las lineas comunes al principio del archivo de entrada
// 	pie -----> con las lneas comunes al final del archivo de entrada.
while (fgets(linea,100, datos) != NULL)
	{
	if (strncmp(linea,"//",2) == 0)
		{
		limpiar(linea);
		if (c == 1)
			{
			fputs(linea, cabeza);
			strcpy(enotas, linea);
			}
		else fputs(linea, pie);
		}
	else c=0;	
	}

// a continuacin se cierran los archivos cabeza y pie, para volver a abrirlo para lectura.	
fclose(cabeza);
fclose(pie);
cabeza=fopen("cabeza", "r");
pie=fopen("pie", "r");
	
rewind(datos); // coloca el apuntador de archivo al inicio de ste


// El while a continuacin posiciona el apuntador de archivo en la primera linea que NO es comun
// a todos los usuarios.
while ((u=fgetc(datos)) == '/')
	{
	fgets(linea, 100, datos);
	}
ungetc(u, datos);
l=strlen(enotas);	
	
	
while ((u=fgetc(datos)) != '/') // se toma un caracter del archivo para comparar
	{
	ungetc(u, datos); // devuelve el caracter que se tom del archivo.
	fscanf(datos, "%s", direccion); // se guarda la direccin de correo en la variable direccin.
	for(j=0;j<=l;j++) personal[j]=32; // limpia el string "personal", que es donde se guardarn las notas de un usuario individual
	j=0;
// El do-while a continuacin se encarga de rellenar el string "personal" con las notas
// correspondientes, en la posicin que corresponda para producir una salida alineada.
	do
		{
		while ((enotas[j] == 32) && (j<l)) j++;
		if (j<l)
			{
			fscanf(datos, "%s", nota);
			for(k=0;k<strlen(nota);k++) personal[j+k]=nota[k];	
			}
		while ((enotas[j] != 32) && (j<l)) j++;
		} while (j<l);
	personal[j]=0; 
	personal[j-1]='\n';
	
	rewind(cabeza); // Se coloca el apuntador de archivo de cabeza al inicio de ste.
	rewind(pie);    // Se coloca el apuntador de archivo de pie al inicio de ste.
	salida=fopen("temp","w"); // Se abre el archivo salida ("temp") para escritura.
	
	// Se copia el archivo cabeza en el archivo salida. 
	while (fgets(linea,100, cabeza) != NULL) fputs(linea,salida);
	// Se copia el string con las notas ("personal") en el archivo salida.
	fputs(personal,salida);
	// Se agrega un retorno de carro adicional (asi sali en la pag web)
	putc('\n',salida);
	// Se copia el archivo pie en el archivo salida.
	while (fgets(linea,100, pie) != NULL) fputs(linea,salida);
	// El archivo salida se cierra y est listo para ser pasado al comando mail
	fclose(salida);
	// Ahora se construye el string con el comando "mail <direccion> <temp"
	// para enviar el archivo de salida generado a la direccin <direccion>
	strcpy(enviar, "mail -s ");
	strcat(enviar, "\"");
	strcat(enviar, argv[1]);
	strcat(enviar, "\" ");
	strcat(enviar, direccion);
	strcat(enviar, " <temp");
	// Se ejecuta el comando de sistema y se enva el correo
	system(enviar);
	while ((u=fgetc(datos)) != '\n') {};
	}

// Se cierran los archivos que quedan abiertos
fclose(pie);
fclose(cabeza);
system("rm cabeza pie temp"); // Borra los archivos temporales
fclose(datos);
return 1;
}